searchData={"content_type":"text/markdown","items":[{"doc":"Whether or not to log (extremely verbose) debug information","ref":"dsl-ashgraphql-api.html#graphql-debug?","title":"AshGraphql.Api.graphql.debug?","type":"DSL"},{"doc":"For security purposes, if an error is *raised* then Ash simply shows a generic error. If you want to show those errors, set this to true.","ref":"dsl-ashgraphql-api.html#graphql-show_raised_errors?","title":"AshGraphql.Api.graphql.show_raised_errors?","type":"DSL"},{"doc":"Set an MFA to intercept/handle any errors that are generated.\n","ref":"dsl-ashgraphql-api.html#graphql-error_handler","title":"AshGraphql.Api.graphql.error_handler","type":"DSL"},{"doc":"By default, mutation errors are shown in their result object's errors key, but this setting places those errors in the top level errors list","ref":"dsl-ashgraphql-api.html#graphql-root_level_errors?","title":"AshGraphql.Api.graphql.root_level_errors?","type":"DSL"},{"doc":"A tracer to use to trace execution in the graphql. Will use `config :ash, :tracer` if it is set.","ref":"dsl-ashgraphql-api.html#graphql-tracer","title":"AshGraphql.Api.graphql.tracer","type":"DSL"},{"doc":"Whether or not to perform authorization for this API","ref":"dsl-ashgraphql-api.html#graphql-authorize?","title":"AshGraphql.Api.graphql.authorize?","type":"DSL"},{"doc":"Global configuration for graphql\n","ref":"dsl-ashgraphql-api.html#graphql","title":"AshGraphql.Api.graphql","type":"DSL"},{"doc":"A keyword list of field names to their graphql type identifiers.\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-types","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.types","type":"DSL"},{"doc":"The name of the input object that will be derived. Defaults to `<action_type>_<resource>_<argument_name>_input`\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-type_name","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.type_name","type":"DSL"},{"doc":"Determines which identities are provided in the input object for looking up, if there is `on_lookup` behavior. Defalts to the `use_identities` option.\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-lookup_identities","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_identities","type":"DSL"},{"doc":"If the managed_relationship has `on_lookup` behavior, this option determines whether or not the primary key is provided in the input object for looking up.\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-lookup_with_primary_key?","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_with_primary_key?","type":"DSL"},{"doc":"The action that accepts the argument","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-action","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.action","type":"DSL"},{"doc":"The argument for which an input object should be derived.","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship-argument","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.argument","type":"DSL"},{"doc":"Instructs ash_graphql that a given argument with a `manage_relationship` change should have its input objects derived automatically from the potential actions to be called.\n\nFor example, given an action like:\n\n```elixir\nactions do\n  create :create do\n    argument :comments, {:array, :map}\n\n    change manage_relationship(:comments, type: :direct_control) # <- we look for this change with a matching argument name\n  end\nend\n```\n\nYou could add the following managed_relationship\n\n```elixir\ngraphql do\n  ...\n\n  managed_relationships do\n    managed_relationship :create, :comments\n  end\nend\n```\n\nBy default, the `{:array, :map}` would simply be a `json[]` type. If the argument name\nis placed in this list, all of the potential actions that could be called will be combined\ninto a single input object. If there are type conflicts (for example, if the input could create\nor update a record, and the create and update actions have an argument of the same name but with a different type),\na warning is emitted at compile time and the first one is used. If that is insufficient, you will need to do one of the following:\n\n1.) provide the `:types` option to the `managed_relationship` constructor (see that option for more)\n2.) define a custom type, with a custom input object (see the custom types guide), and use that custom type instead of `:map`\n3.) change your actions to not have overlapping inputs with different types\n\nSince managed relationships can ultimately call multiple actions, there is the possibility\nof field type conflicts. Use the `types` option to determine the type of fields and remove the conflict warnings.\n\nFor `non_null` use `{:non_null, type}`, and for a list, use `{:array, type}`, for example:\n\n`{:non_null, {:array, {:non_null, :string}}}` for a non null list of non null strings.\n\nTo *remove* a key from the input object, simply pass `nil` as the type.\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-managed_relationship","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship","type":"DSL"},{"doc":"Automatically derive types for all arguments that have a `manage_relationship` call change.","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships-auto?","title":"AshGraphql.Resource.graphql.managed_relationships.auto?","type":"DSL"},{"doc":"Generates input objects for `manage_relationship` arguments on resource actions.\n","ref":"dsl-ashgraphql-resource.html#graphql-managed_relationships","title":"AshGraphql.Resource.graphql.managed_relationships","type":"DSL"},{"doc":"The action to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-action-action","title":"AshGraphql.Resource.graphql.mutations.action.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-action-name","title":"AshGraphql.Resource.graphql.mutations.action.name","type":"DSL"},{"doc":"Runs a generic action","ref":"dsl-ashgraphql-resource.html#graphql-mutations-action","title":"AshGraphql.Resource.graphql.mutations.action","type":"DSL"},{"doc":"The identity to use to fetch the record to be destroyed. Use `false` if no identity is required.\n","ref":"dsl-ashgraphql-resource.html#graphql-mutations-destroy-identity","title":"AshGraphql.Resource.graphql.mutations.destroy.identity","type":"DSL"},{"doc":"The read action to use to fetch the record to be destroyed. Defaults to the primary read action.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-destroy-read_action","title":"AshGraphql.Resource.graphql.mutations.destroy.read_action","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-destroy-action","title":"AshGraphql.Resource.graphql.mutations.destroy.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-destroy-name","title":"AshGraphql.Resource.graphql.mutations.destroy.name","type":"DSL"},{"doc":"A mutation to destroy a record","ref":"dsl-ashgraphql-resource.html#graphql-mutations-destroy","title":"AshGraphql.Resource.graphql.mutations.destroy","type":"DSL"},{"doc":"The read action to use to fetch the record to be updated. Defaults to the primary read action.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-update-read_action","title":"AshGraphql.Resource.graphql.mutations.update.read_action","type":"DSL"},{"doc":"The identity to use to fetch the record to be updated. Use `false` if no identity is required.\n","ref":"dsl-ashgraphql-resource.html#graphql-mutations-update-identity","title":"AshGraphql.Resource.graphql.mutations.update.identity","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-update-action","title":"AshGraphql.Resource.graphql.mutations.update.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-update-name","title":"AshGraphql.Resource.graphql.mutations.update.name","type":"DSL"},{"doc":"A mutation to update a record","ref":"dsl-ashgraphql-resource.html#graphql-mutations-update","title":"AshGraphql.Resource.graphql.mutations.update","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create-modify_resolution","title":"AshGraphql.Resource.graphql.mutations.create.modify_resolution","type":"DSL"},{"doc":"Which identity to use for the upsert","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create-upsert_identity","title":"AshGraphql.Resource.graphql.mutations.create.upsert_identity","type":"DSL"},{"doc":"Whether or not to use the `upsert?: true` option when calling `YourApi.create/2`.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create-upsert?","title":"AshGraphql.Resource.graphql.mutations.create.upsert?","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create-action","title":"AshGraphql.Resource.graphql.mutations.create.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create-name","title":"AshGraphql.Resource.graphql.mutations.create.name","type":"DSL"},{"doc":"A mutation to create a record","ref":"dsl-ashgraphql-resource.html#graphql-mutations-create","title":"AshGraphql.Resource.graphql.mutations.create","type":"DSL"},{"doc":"Mutations (create/update/destroy actions) to expose for the resource.\n","ref":"dsl-ashgraphql-resource.html#graphql-mutations","title":"AshGraphql.Resource.graphql.mutations","type":"DSL"},{"doc":"The action to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-action-action","title":"AshGraphql.Resource.graphql.queries.action.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-action-name","title":"AshGraphql.Resource.graphql.queries.action.name","type":"DSL"},{"doc":"Runs a generic action","ref":"dsl-ashgraphql-resource.html#graphql-queries-action","title":"AshGraphql.Resource.graphql.queries.action","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-as_mutation?","title":"AshGraphql.Resource.graphql.queries.list.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-show_metadata","title":"AshGraphql.Resource.graphql.queries.list.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-metadata_types","title":"AshGraphql.Resource.graphql.queries.list.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-metadata_names","title":"AshGraphql.Resource.graphql.queries.list.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-type_name","title":"AshGraphql.Resource.graphql.queries.list.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-action","title":"AshGraphql.Resource.graphql.queries.list.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-name","title":"AshGraphql.Resource.graphql.queries.list.name","type":"DSL"},{"doc":"If true, the graphql queries/resolvers for this resource will be built to honor the relay specification. See [the relay guide](/documentation/topics/relay.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-list-relay?","title":"AshGraphql.Resource.graphql.queries.list.relay?","type":"DSL"},{"doc":"A query to fetch a list of records","ref":"dsl-ashgraphql-resource.html#graphql-queries-list","title":"AshGraphql.Resource.graphql.queries.list","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-as_mutation?","title":"AshGraphql.Resource.graphql.queries.read_one.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-show_metadata","title":"AshGraphql.Resource.graphql.queries.read_one.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-metadata_types","title":"AshGraphql.Resource.graphql.queries.read_one.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-metadata_names","title":"AshGraphql.Resource.graphql.queries.read_one.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-type_name","title":"AshGraphql.Resource.graphql.queries.read_one.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-action","title":"AshGraphql.Resource.graphql.queries.read_one.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-name","title":"AshGraphql.Resource.graphql.queries.read_one.name","type":"DSL"},{"doc":"Whether or not the action can return nil.","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one-allow_nil?","title":"AshGraphql.Resource.graphql.queries.read_one.allow_nil?","type":"DSL"},{"doc":"A query to fetch a record","ref":"dsl-ashgraphql-resource.html#graphql-queries-read_one","title":"AshGraphql.Resource.graphql.queries.read_one","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-as_mutation?","title":"AshGraphql.Resource.graphql.queries.get.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-show_metadata","title":"AshGraphql.Resource.graphql.queries.get.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-metadata_types","title":"AshGraphql.Resource.graphql.queries.get.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-metadata_names","title":"AshGraphql.Resource.graphql.queries.get.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-type_name","title":"AshGraphql.Resource.graphql.queries.get.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-action","title":"AshGraphql.Resource.graphql.queries.get.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-name","title":"AshGraphql.Resource.graphql.queries.get.name","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-modify_resolution","title":"AshGraphql.Resource.graphql.queries.get.modify_resolution","type":"DSL"},{"doc":"Whether or not the action can return nil.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-allow_nil?","title":"AshGraphql.Resource.graphql.queries.get.allow_nil?","type":"DSL"},{"doc":"The identity to use for looking up the record. Pass `false` to not use an identity.","ref":"dsl-ashgraphql-resource.html#graphql-queries-get-identity","title":"AshGraphql.Resource.graphql.queries.get.identity","type":"DSL"},{"doc":"A query to fetch a record by primary key","ref":"dsl-ashgraphql-resource.html#graphql-queries-get","title":"AshGraphql.Resource.graphql.queries.get","type":"DSL"},{"doc":"Queries (read actions) to expose for the resource.\n","ref":"dsl-ashgraphql-resource.html#graphql-queries","title":"AshGraphql.Resource.graphql.queries","type":"DSL"},{"doc":"A list of fields that are allowed to be filtered on. Defaults to all filterable fields for which a GraphQL type can be created.","ref":"dsl-ashgraphql-resource.html#graphql-filterable_fields","title":"AshGraphql.Resource.graphql.filterable_fields","type":"DSL"},{"doc":"Whether or not to create the GraphQL object, this allows you to manually create the GraphQL object.","ref":"dsl-ashgraphql-resource.html#graphql-generate_object?","title":"AshGraphql.Resource.graphql.generate_object?","type":"DSL"},{"doc":"A simple way to prevent massive queries.\n","ref":"dsl-ashgraphql-resource.html#graphql-depth_limit","title":"AshGraphql.Resource.graphql.depth_limit","type":"DSL"},{"doc":"If a composite primary key exists, this can be set to determine delimiter used in the `id` field value.","ref":"dsl-ashgraphql-resource.html#graphql-primary_key_delimiter","title":"AshGraphql.Resource.graphql.primary_key_delimiter","type":"DSL"},{"doc":"A keyword list of input type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.","ref":"dsl-ashgraphql-resource.html#graphql-attribute_input_types","title":"AshGraphql.Resource.graphql.attribute_input_types","type":"DSL"},{"doc":"A keyword list of type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.","ref":"dsl-ashgraphql-resource.html#graphql-attribute_types","title":"AshGraphql.Resource.graphql.attribute_types","type":"DSL"},{"doc":"If set, the keyset will be displayed on all read actions in this field.  It will be `nil` unless at least one of the read actions on a resource uses keyset pagination or it is the result of a mutation\n","ref":"dsl-ashgraphql-resource.html#graphql-keyset_field","title":"AshGraphql.Resource.graphql.keyset_field","type":"DSL"},{"doc":"A nested keyword list of action names, to argument name remappings. i.e `create: [arg_name: :new_name]`","ref":"dsl-ashgraphql-resource.html#graphql-argument_names","title":"AshGraphql.Resource.graphql.argument_names","type":"DSL"},{"doc":"A list of attributes to hide from the api","ref":"dsl-ashgraphql-resource.html#graphql-hide_fields","title":"AshGraphql.Resource.graphql.hide_fields","type":"DSL"},{"doc":"A keyword list of name overrides for attributes.","ref":"dsl-ashgraphql-resource.html#graphql-field_names","title":"AshGraphql.Resource.graphql.field_names","type":"DSL"},{"doc":"A list of relationships to include on the created type. Defaults to all public relationships where the destination defines a graphql type.","ref":"dsl-ashgraphql-resource.html#graphql-relationships","title":"AshGraphql.Resource.graphql.relationships","type":"DSL"},{"doc":"For resources with composite primary keys, or primary keys not called `:id`, this will cause the id to be encoded as a single `id` attribute, both in the representation of the resource and in get requests","ref":"dsl-ashgraphql-resource.html#graphql-encode_primary_key?","title":"AshGraphql.Resource.graphql.encode_primary_key?","type":"DSL"},{"doc":"Set to false to disable the automatic generation of a sort input for read actions.\n","ref":"dsl-ashgraphql-resource.html#graphql-derive_sort?","title":"AshGraphql.Resource.graphql.derive_sort?","type":"DSL"},{"doc":"Set to false to disable the automatic generation of a filter input for read actions.\n","ref":"dsl-ashgraphql-resource.html#graphql-derive_filter?","title":"AshGraphql.Resource.graphql.derive_filter?","type":"DSL"},{"doc":"The type to use for this entity in the graphql schema","ref":"dsl-ashgraphql-resource.html#graphql-type","title":"AshGraphql.Resource.graphql.type","type":"DSL"},{"doc":"Configuration for a given resource in graphql\n","ref":"dsl-ashgraphql-resource.html#graphql","title":"AshGraphql.Resource.graphql","type":"DSL"},{"doc":"Whether or not to log (extremely verbose) debug information","ref":"AshGraphql.Api.html#graphql-debug?","title":"AshGraphql.Api.graphql.debug?","type":"DSL"},{"doc":"For security purposes, if an error is *raised* then Ash simply shows a generic error. If you want to show those errors, set this to true.","ref":"AshGraphql.Api.html#graphql-show_raised_errors?","title":"AshGraphql.Api.graphql.show_raised_errors?","type":"DSL"},{"doc":"Set an MFA to intercept/handle any errors that are generated.\n","ref":"AshGraphql.Api.html#graphql-error_handler","title":"AshGraphql.Api.graphql.error_handler","type":"DSL"},{"doc":"By default, mutation errors are shown in their result object's errors key, but this setting places those errors in the top level errors list","ref":"AshGraphql.Api.html#graphql-root_level_errors?","title":"AshGraphql.Api.graphql.root_level_errors?","type":"DSL"},{"doc":"A tracer to use to trace execution in the graphql. Will use `config :ash, :tracer` if it is set.","ref":"AshGraphql.Api.html#graphql-tracer","title":"AshGraphql.Api.graphql.tracer","type":"DSL"},{"doc":"Whether or not to perform authorization for this API","ref":"AshGraphql.Api.html#graphql-authorize?","title":"AshGraphql.Api.graphql.authorize?","type":"DSL"},{"doc":"Global configuration for graphql\n","ref":"AshGraphql.Api.html#graphql","title":"AshGraphql.Api.graphql","type":"DSL"},{"doc":"A keyword list of field names to their graphql type identifiers.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-types","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.types","type":"DSL"},{"doc":"The name of the input object that will be derived. Defaults to `<action_type>_<resource>_<argument_name>_input`\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-type_name","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.type_name","type":"DSL"},{"doc":"Determines which identities are provided in the input object for looking up, if there is `on_lookup` behavior. Defalts to the `use_identities` option.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-lookup_identities","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_identities","type":"DSL"},{"doc":"If the managed_relationship has `on_lookup` behavior, this option determines whether or not the primary key is provided in the input object for looking up.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-lookup_with_primary_key?","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_with_primary_key?","type":"DSL"},{"doc":"The action that accepts the argument","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-action","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.action","type":"DSL"},{"doc":"The argument for which an input object should be derived.","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-argument","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.argument","type":"DSL"},{"doc":"Instructs ash_graphql that a given argument with a `manage_relationship` change should have its input objects derived automatically from the potential actions to be called.\n\nFor example, given an action like:\n\n```elixir\nactions do\n  create :create do\n    argument :comments, {:array, :map}\n\n    change manage_relationship(:comments, type: :direct_control) # <- we look for this change with a matching argument name\n  end\nend\n```\n\nYou could add the following managed_relationship\n\n```elixir\ngraphql do\n  ...\n\n  managed_relationships do\n    managed_relationship :create, :comments\n  end\nend\n```\n\nBy default, the `{:array, :map}` would simply be a `json[]` type. If the argument name\nis placed in this list, all of the potential actions that could be called will be combined\ninto a single input object. If there are type conflicts (for example, if the input could create\nor update a record, and the create and update actions have an argument of the same name but with a different type),\na warning is emitted at compile time and the first one is used. If that is insufficient, you will need to do one of the following:\n\n1.) provide the `:types` option to the `managed_relationship` constructor (see that option for more)\n2.) define a custom type, with a custom input object (see the custom types guide), and use that custom type instead of `:map`\n3.) change your actions to not have overlapping inputs with different types\n\nSince managed relationships can ultimately call multiple actions, there is the possibility\nof field type conflicts. Use the `types` option to determine the type of fields and remove the conflict warnings.\n\nFor `non_null` use `{:non_null, type}`, and for a list, use `{:array, type}`, for example:\n\n`{:non_null, {:array, {:non_null, :string}}}` for a non null list of non null strings.\n\nTo *remove* a key from the input object, simply pass `nil` as the type.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship","type":"DSL"},{"doc":"Automatically derive types for all arguments that have a `manage_relationship` call change.","ref":"AshGraphql.Resource.html#graphql-managed_relationships-auto?","title":"AshGraphql.Resource.graphql.managed_relationships.auto?","type":"DSL"},{"doc":"Generates input objects for `manage_relationship` arguments on resource actions.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships","title":"AshGraphql.Resource.graphql.managed_relationships","type":"DSL"},{"doc":"The action to use for the query.","ref":"AshGraphql.Resource.html#graphql-mutations-action-action","title":"AshGraphql.Resource.graphql.mutations.action.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"AshGraphql.Resource.html#graphql-mutations-action-name","title":"AshGraphql.Resource.graphql.mutations.action.name","type":"DSL"},{"doc":"Runs a generic action","ref":"AshGraphql.Resource.html#graphql-mutations-action","title":"AshGraphql.Resource.graphql.mutations.action","type":"DSL"},{"doc":"The identity to use to fetch the record to be destroyed. Use `false` if no identity is required.\n","ref":"AshGraphql.Resource.html#graphql-mutations-destroy-identity","title":"AshGraphql.Resource.graphql.mutations.destroy.identity","type":"DSL"},{"doc":"The read action to use to fetch the record to be destroyed. Defaults to the primary read action.","ref":"AshGraphql.Resource.html#graphql-mutations-destroy-read_action","title":"AshGraphql.Resource.graphql.mutations.destroy.read_action","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-destroy-action","title":"AshGraphql.Resource.graphql.mutations.destroy.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-destroy-name","title":"AshGraphql.Resource.graphql.mutations.destroy.name","type":"DSL"},{"doc":"A mutation to destroy a record","ref":"AshGraphql.Resource.html#graphql-mutations-destroy","title":"AshGraphql.Resource.graphql.mutations.destroy","type":"DSL"},{"doc":"The read action to use to fetch the record to be updated. Defaults to the primary read action.","ref":"AshGraphql.Resource.html#graphql-mutations-update-read_action","title":"AshGraphql.Resource.graphql.mutations.update.read_action","type":"DSL"},{"doc":"The identity to use to fetch the record to be updated. Use `false` if no identity is required.\n","ref":"AshGraphql.Resource.html#graphql-mutations-update-identity","title":"AshGraphql.Resource.graphql.mutations.update.identity","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-update-action","title":"AshGraphql.Resource.graphql.mutations.update.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-update-name","title":"AshGraphql.Resource.graphql.mutations.update.name","type":"DSL"},{"doc":"A mutation to update a record","ref":"AshGraphql.Resource.html#graphql-mutations-update","title":"AshGraphql.Resource.graphql.mutations.update","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-mutations-create-modify_resolution","title":"AshGraphql.Resource.graphql.mutations.create.modify_resolution","type":"DSL"},{"doc":"Which identity to use for the upsert","ref":"AshGraphql.Resource.html#graphql-mutations-create-upsert_identity","title":"AshGraphql.Resource.graphql.mutations.create.upsert_identity","type":"DSL"},{"doc":"Whether or not to use the `upsert?: true` option when calling `YourApi.create/2`.","ref":"AshGraphql.Resource.html#graphql-mutations-create-upsert?","title":"AshGraphql.Resource.graphql.mutations.create.upsert?","type":"DSL"},{"doc":"The action to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-create-action","title":"AshGraphql.Resource.graphql.mutations.create.action","type":"DSL"},{"doc":"The name to use for the mutation.","ref":"AshGraphql.Resource.html#graphql-mutations-create-name","title":"AshGraphql.Resource.graphql.mutations.create.name","type":"DSL"},{"doc":"A mutation to create a record","ref":"AshGraphql.Resource.html#graphql-mutations-create","title":"AshGraphql.Resource.graphql.mutations.create","type":"DSL"},{"doc":"Mutations (create/update/destroy actions) to expose for the resource.\n","ref":"AshGraphql.Resource.html#graphql-mutations","title":"AshGraphql.Resource.graphql.mutations","type":"DSL"},{"doc":"The action to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-action-action","title":"AshGraphql.Resource.graphql.queries.action.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-action-name","title":"AshGraphql.Resource.graphql.queries.action.name","type":"DSL"},{"doc":"Runs a generic action","ref":"AshGraphql.Resource.html#graphql-queries-action","title":"AshGraphql.Resource.graphql.queries.action","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-as_mutation?","title":"AshGraphql.Resource.graphql.queries.list.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"AshGraphql.Resource.html#graphql-queries-list-show_metadata","title":"AshGraphql.Resource.graphql.queries.list.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-list-metadata_types","title":"AshGraphql.Resource.graphql.queries.list.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-list-metadata_names","title":"AshGraphql.Resource.graphql.queries.list.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-type_name","title":"AshGraphql.Resource.graphql.queries.list.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-list-action","title":"AshGraphql.Resource.graphql.queries.list.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-list-name","title":"AshGraphql.Resource.graphql.queries.list.name","type":"DSL"},{"doc":"If true, the graphql queries/resolvers for this resource will be built to honor the relay specification. See [the relay guide](/documentation/topics/relay.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-relay?","title":"AshGraphql.Resource.graphql.queries.list.relay?","type":"DSL"},{"doc":"A query to fetch a list of records","ref":"AshGraphql.Resource.html#graphql-queries-list","title":"AshGraphql.Resource.graphql.queries.list","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-read_one-as_mutation?","title":"AshGraphql.Resource.graphql.queries.read_one.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-show_metadata","title":"AshGraphql.Resource.graphql.queries.read_one.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-metadata_types","title":"AshGraphql.Resource.graphql.queries.read_one.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-metadata_names","title":"AshGraphql.Resource.graphql.queries.read_one.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"AshGraphql.Resource.html#graphql-queries-read_one-type_name","title":"AshGraphql.Resource.graphql.queries.read_one.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-action","title":"AshGraphql.Resource.graphql.queries.read_one.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-name","title":"AshGraphql.Resource.graphql.queries.read_one.name","type":"DSL"},{"doc":"Whether or not the action can return nil.","ref":"AshGraphql.Resource.html#graphql-queries-read_one-allow_nil?","title":"AshGraphql.Resource.graphql.queries.read_one.allow_nil?","type":"DSL"},{"doc":"A query to fetch a record","ref":"AshGraphql.Resource.html#graphql-queries-read_one","title":"AshGraphql.Resource.graphql.queries.read_one","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. Not typically necessary, but is often paired with `as_mutation?`. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-as_mutation?","title":"AshGraphql.Resource.graphql.queries.get.as_mutation?","type":"DSL"},{"doc":"The metadata attributes to show. Defaults to all.","ref":"AshGraphql.Resource.html#graphql-queries-get-show_metadata","title":"AshGraphql.Resource.graphql.queries.get.show_metadata","type":"DSL"},{"doc":"Type overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-get-metadata_types","title":"AshGraphql.Resource.graphql.queries.get.metadata_types","type":"DSL"},{"doc":"Name overrides for metadata fields on the read action.","ref":"AshGraphql.Resource.html#graphql-queries-get-metadata_names","title":"AshGraphql.Resource.graphql.queries.get.metadata_names","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata` that is not hidden via the `show_metadata` key.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-type_name","title":"AshGraphql.Resource.graphql.queries.get.type_name","type":"DSL"},{"doc":"The action to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-get-action","title":"AshGraphql.Resource.graphql.queries.get.action","type":"DSL"},{"doc":"The name to use for the query.","ref":"AshGraphql.Resource.html#graphql-queries-get-name","title":"AshGraphql.Resource.graphql.queries.get.name","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments. See the [the guide](/documentation/topics/modifying-the-resolution.html) for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-modify_resolution","title":"AshGraphql.Resource.graphql.queries.get.modify_resolution","type":"DSL"},{"doc":"Whether or not the action can return nil.","ref":"AshGraphql.Resource.html#graphql-queries-get-allow_nil?","title":"AshGraphql.Resource.graphql.queries.get.allow_nil?","type":"DSL"},{"doc":"The identity to use for looking up the record. Pass `false` to not use an identity.","ref":"AshGraphql.Resource.html#graphql-queries-get-identity","title":"AshGraphql.Resource.graphql.queries.get.identity","type":"DSL"},{"doc":"A query to fetch a record by primary key","ref":"AshGraphql.Resource.html#graphql-queries-get","title":"AshGraphql.Resource.graphql.queries.get","type":"DSL"},{"doc":"Queries (read actions) to expose for the resource.\n","ref":"AshGraphql.Resource.html#graphql-queries","title":"AshGraphql.Resource.graphql.queries","type":"DSL"},{"doc":"A list of fields that are allowed to be filtered on. Defaults to all filterable fields for which a GraphQL type can be created.","ref":"AshGraphql.Resource.html#graphql-filterable_fields","title":"AshGraphql.Resource.graphql.filterable_fields","type":"DSL"},{"doc":"Whether or not to create the GraphQL object, this allows you to manually create the GraphQL object.","ref":"AshGraphql.Resource.html#graphql-generate_object?","title":"AshGraphql.Resource.graphql.generate_object?","type":"DSL"},{"doc":"A simple way to prevent massive queries.\n","ref":"AshGraphql.Resource.html#graphql-depth_limit","title":"AshGraphql.Resource.graphql.depth_limit","type":"DSL"},{"doc":"If a composite primary key exists, this can be set to determine delimiter used in the `id` field value.","ref":"AshGraphql.Resource.html#graphql-primary_key_delimiter","title":"AshGraphql.Resource.graphql.primary_key_delimiter","type":"DSL"},{"doc":"A keyword list of input type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.","ref":"AshGraphql.Resource.html#graphql-attribute_input_types","title":"AshGraphql.Resource.graphql.attribute_input_types","type":"DSL"},{"doc":"A keyword list of type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.","ref":"AshGraphql.Resource.html#graphql-attribute_types","title":"AshGraphql.Resource.graphql.attribute_types","type":"DSL"},{"doc":"If set, the keyset will be displayed on all read actions in this field.  It will be `nil` unless at least one of the read actions on a resource uses keyset pagination or it is the result of a mutation\n","ref":"AshGraphql.Resource.html#graphql-keyset_field","title":"AshGraphql.Resource.graphql.keyset_field","type":"DSL"},{"doc":"A nested keyword list of action names, to argument name remappings. i.e `create: [arg_name: :new_name]`","ref":"AshGraphql.Resource.html#graphql-argument_names","title":"AshGraphql.Resource.graphql.argument_names","type":"DSL"},{"doc":"A list of attributes to hide from the api","ref":"AshGraphql.Resource.html#graphql-hide_fields","title":"AshGraphql.Resource.graphql.hide_fields","type":"DSL"},{"doc":"A keyword list of name overrides for attributes.","ref":"AshGraphql.Resource.html#graphql-field_names","title":"AshGraphql.Resource.graphql.field_names","type":"DSL"},{"doc":"A list of relationships to include on the created type. Defaults to all public relationships where the destination defines a graphql type.","ref":"AshGraphql.Resource.html#graphql-relationships","title":"AshGraphql.Resource.graphql.relationships","type":"DSL"},{"doc":"For resources with composite primary keys, or primary keys not called `:id`, this will cause the id to be encoded as a single `id` attribute, both in the representation of the resource and in get requests","ref":"AshGraphql.Resource.html#graphql-encode_primary_key?","title":"AshGraphql.Resource.graphql.encode_primary_key?","type":"DSL"},{"doc":"Set to false to disable the automatic generation of a sort input for read actions.\n","ref":"AshGraphql.Resource.html#graphql-derive_sort?","title":"AshGraphql.Resource.graphql.derive_sort?","type":"DSL"},{"doc":"Set to false to disable the automatic generation of a filter input for read actions.\n","ref":"AshGraphql.Resource.html#graphql-derive_filter?","title":"AshGraphql.Resource.graphql.derive_filter?","type":"DSL"},{"doc":"The type to use for this entity in the graphql schema","ref":"AshGraphql.Resource.html#graphql-type","title":"AshGraphql.Resource.graphql.type","type":"DSL"},{"doc":"Configuration for a given resource in graphql\n","ref":"AshGraphql.Resource.html#graphql","title":"AshGraphql.Resource.graphql","type":"DSL"},{"doc":"If true, the graphql queries/resolvers for this resource will be built to honor the [relay specification](https://relay.dev/graphql/connections.htm).\n\nThe two changes that are made currently are:\n\n* the type for the resource will implement the `Node` interface\n* pagination over that resource will behave as a Connection.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-relay?","title":"AshGraphql.Resource.graphql.queries.list.relay?","type":"DSL"},{"doc":"If set, the keyset will be displayed on all read actions in this field.\n\nIt will always be `nil` unless at least one of the read actions on a resource uses keyset pagination.\nIt will also be nil on any mutation results.\n","ref":"AshGraphql.Resource.html#graphql-keyset_field","title":"AshGraphql.Resource.graphql.keyset_field","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. The use cases for this are likely very minimal.\n\nIf you have a query that needs to modify the graphql context using `modify_resolution`, then you\nshould likely set this as well. A simple example might be a `log_in`, which could be a read\naction on the user that accepts an email/password, and should then set some context in the graphql\ninside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\nfor more on setting the session or a cookie with an auth token.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-as_mutation?","title":"AshGraphql.Resource.graphql.queries.list.as_mutation?","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata`.\n\nTo ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\nTo show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\nincludes the additional fields.\n","ref":"AshGraphql.Resource.html#graphql-queries-list-type_name","title":"AshGraphql.Resource.graphql.queries.list.type_name","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. The use cases for this are likely very minimal.\n\nIf you have a query that needs to modify the graphql context using `modify_resolution`, then you\nshould likely set this as well. A simple example might be a `log_in`, which could be a read\naction on the user that accepts an email/password, and should then set some context in the graphql\ninside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\nfor more on setting the session or a cookie with an auth token.\n","ref":"AshGraphql.Resource.html#graphql-queries-read_one-as_mutation?","title":"AshGraphql.Resource.graphql.queries.read_one.as_mutation?","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata`.\n\nTo ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\nTo show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\nincludes the additional fields.\n","ref":"AshGraphql.Resource.html#graphql-queries-read_one-type_name","title":"AshGraphql.Resource.graphql.queries.read_one.type_name","type":"DSL"},{"doc":"Places the query in the `mutations` key instead. The use cases for this are likely very minimal.\n\nIf you have a query that needs to modify the graphql context using `modify_resolution`, then you\nshould likely set this as well. A simple example might be a `log_in`, which could be a read\naction on the user that accepts an email/password, and should then set some context in the graphql\ninside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\nfor more on setting the session or a cookie with an auth token.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-as_mutation?","title":"AshGraphql.Resource.graphql.queries.get.as_mutation?","type":"DSL"},{"doc":"Override the type name returned by this query. Must be set if the read action has `metadata`.\n\nTo ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\nTo show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\nincludes the additional fields.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-type_name","title":"AshGraphql.Resource.graphql.queries.get.type_name","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the changeset, and the result of the action as the first three arguments (followed by the arguments in the mfa).\nMust return a new absinthe resolution. This can be used to implement things like setting cookies based on resource actions. A method of using resolution context\nfor that is documented here: https://hexdocs.pm/absinthe_plug/Absinthe.Plug.html#module-before-send\n","ref":"AshGraphql.Resource.html#graphql-mutations-create-modify_resolution","title":"AshGraphql.Resource.graphql.mutations.create.modify_resolution","type":"DSL"},{"doc":"An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments (followed by the arguments in the mfa).\nMust return a new absinthe resolution. This can be used to implement things like setting cookies based on resource actions. A method of using resolution context\nfor that is documented here: https://hexdocs.pm/absinthe_plug/Absinthe.Plug.html#module-before-send\n\n*Important* if you are modifying the context, then you should also set `as_mutation?` to true and represent\nthis in your graphql as a mutation. See `as_mutation?` for more.\n","ref":"AshGraphql.Resource.html#graphql-queries-get-modify_resolution","title":"AshGraphql.Resource.graphql.queries.get.modify_resolution","type":"DSL"},{"doc":"If the managed_relationship has `on_lookup` behavior, this option determines which identities are provided in the input object for looking up.\n\nThis option is ignored if there is no `on_lookup`. By default *all* identities are provided.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-lookup_identities","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_identities","type":"DSL"},{"doc":"If the managed_relationship has `on_lookup` behavior, this option determines whether or not the primary key is provided in the input object for looking up.\n\nThis option is ignored if there is no `on_lookup`.\n","ref":"AshGraphql.Resource.html#graphql-managed_relationships-managed_relationship-lookup_with_primary_key?","title":"AshGraphql.Resource.graphql.managed_relationships.managed_relationship.lookup_with_primary_key?","type":"DSL"},{"doc":"The identity to use to fetch the record to be destroyed.\nIf no identity is required (e.g for a read action that already knows how to fetch the item to be updated), use `false`.\n","ref":"AshGraphql.Resource.html#graphql-mutations-destroy-identity","title":"AshGraphql.Resource.graphql.mutations.destroy.identity","type":"DSL"},{"doc":"The identity to use to fetch the record to be updated.\n\nIf no identity is required (e.g for a read action that already knows how to fetch the item to be updated), use `false`.\n","ref":"AshGraphql.Resource.html#graphql-mutations-update-identity","title":"AshGraphql.Resource.graphql.mutations.update.identity","type":"DSL"},{"doc":"AshGraphql is a GraphQL extension for the Ash framework.\n\nFor more information, see the [getting started guide](/documentation/tutorials/getting-started-with-graphql.md)","ref":"AshGraphql.html","title":"AshGraphql","type":"module"},{"doc":"","ref":"AshGraphql.html#add_context/3","title":"AshGraphql.add_context/3","type":"function"},{"doc":"","ref":"AshGraphql.html#get_embed/1","title":"AshGraphql.get_embed/1","type":"function"},{"doc":"","ref":"AshGraphql.html#get_embedded_types/2","title":"AshGraphql.get_embedded_types/2","type":"function"},{"doc":"","ref":"AshGraphql.html#global_enums/3","title":"AshGraphql.global_enums/3","type":"function"},{"doc":"","ref":"AshGraphql.html#global_unions/3","title":"AshGraphql.global_unions/3","type":"function"},{"doc":"","ref":"AshGraphql.html#mutation/1","title":"AshGraphql.mutation/1","type":"macro"},{"doc":"Introspection helpers for AshGraphql.Api","ref":"AshGraphql.Api.Info.html","title":"AshGraphql.Api.Info","type":"module"},{"doc":"Wether or not to run authorization on this api","ref":"AshGraphql.Api.Info.html#authorize?/1","title":"AshGraphql.Api.Info.authorize?/1","type":"function"},{"doc":"Wether or not to pass debug? down to internal execution","ref":"AshGraphql.Api.Info.html#debug?/1","title":"AshGraphql.Api.Info.debug?/1","type":"function"},{"doc":"An error handler for errors produced by api","ref":"AshGraphql.Api.Info.html#error_handler/1","title":"AshGraphql.Api.Info.error_handler/1","type":"function"},{"doc":"Wether or not to surface errors to the root of the response","ref":"AshGraphql.Api.Info.html#root_level_errors?/1","title":"AshGraphql.Api.Info.root_level_errors?/1","type":"function"},{"doc":"Wether or not to render raised errors in the graphql response","ref":"AshGraphql.Api.Info.html#show_raised_errors?/1","title":"AshGraphql.Api.Info.show_raised_errors?/1","type":"function"},{"doc":"The tracer to use for the given schema","ref":"AshGraphql.Api.Info.html#tracer/1","title":"AshGraphql.Api.Info.tracer/1","type":"function"},{"doc":"Introspection helpers for AshGraphql.Resource","ref":"AshGraphql.Resource.Info.html","title":"AshGraphql.Resource.Info","type":"module"},{"doc":"Graphql argument name overrides for the resource","ref":"AshGraphql.Resource.Info.html#argument_names/1","title":"AshGraphql.Resource.Info.argument_names/1","type":"function"},{"doc":"Graphql type overrides for the resource","ref":"AshGraphql.Resource.Info.html#attribute_input_types/1","title":"AshGraphql.Resource.Info.attribute_input_types/1","type":"function"},{"doc":"Graphql type overrides for the resource","ref":"AshGraphql.Resource.Info.html#attribute_types/1","title":"AshGraphql.Resource.Info.attribute_types/1","type":"function"},{"doc":"Wether or not to derive a filter input for the resource automatically","ref":"AshGraphql.Resource.Info.html#derive_filter?/1","title":"AshGraphql.Resource.Info.derive_filter?/1","type":"function"},{"doc":"Wether or not to derive a sort input for the resource automatically","ref":"AshGraphql.Resource.Info.html#derive_sort?/1","title":"AshGraphql.Resource.Info.derive_sort?/1","type":"function"},{"doc":"Wether or not to encode the primary key as a single `id` field when reading and getting","ref":"AshGraphql.Resource.Info.html#encode_primary_key?/1","title":"AshGraphql.Resource.Info.encode_primary_key?/1","type":"function"},{"doc":"Graphql field name (attribute/relationship/calculation/arguments) overrides for the resource","ref":"AshGraphql.Resource.Info.html#field_names/1","title":"AshGraphql.Resource.Info.field_names/1","type":"function"},{"doc":"May the specified field be filtered on?","ref":"AshGraphql.Resource.Info.html#filterable_field?/2","title":"AshGraphql.Resource.Info.filterable_field?/2","type":"function"},{"doc":"Fields that may be filtered on","ref":"AshGraphql.Resource.Info.html#filterable_fields/1","title":"AshGraphql.Resource.Info.filterable_fields/1","type":"function"},{"doc":"Wether or not an object should be generated, or if one with the type name for this resource should be used.","ref":"AshGraphql.Resource.Info.html#generate_object?/1","title":"AshGraphql.Resource.Info.generate_object?/1","type":"function"},{"doc":"Fields to hide from the graphql api","ref":"AshGraphql.Resource.Info.html#hide_fields/1","title":"AshGraphql.Resource.Info.hide_fields/1","type":"function"},{"doc":"The field name to place the keyset of a result in","ref":"AshGraphql.Resource.Info.html#keyset_field/1","title":"AshGraphql.Resource.Info.keyset_field/1","type":"function"},{"doc":"The managed_relationshi configuration for a given action/argument","ref":"AshGraphql.Resource.Info.html#managed_relationship/3","title":"AshGraphql.Resource.Info.managed_relationship/3","type":"function"},{"doc":"The managed_relationship configurations","ref":"AshGraphql.Resource.Info.html#managed_relationships/1","title":"AshGraphql.Resource.Info.managed_relationships/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Info.html#managed_relationships_auto?/1","title":"AshGraphql.Resource.Info.managed_relationships_auto?/1","type":"function"},{"doc":"The mutations exposed for the resource","ref":"AshGraphql.Resource.Info.html#mutations/1","title":"AshGraphql.Resource.Info.mutations/1","type":"function"},{"doc":"The delimiter for a resource with a composite primary key","ref":"AshGraphql.Resource.Info.html#primary_key_delimiter/1","title":"AshGraphql.Resource.Info.primary_key_delimiter/1","type":"function"},{"doc":"The queries exposed for the resource","ref":"AshGraphql.Resource.Info.html#queries/1","title":"AshGraphql.Resource.Info.queries/1","type":"function"},{"doc":"Which relationships should be included in the generated type","ref":"AshGraphql.Resource.Info.html#relationships/1","title":"AshGraphql.Resource.Info.relationships/1","type":"function"},{"doc":"Wether or not a given field will be shown","ref":"AshGraphql.Resource.Info.html#show_field?/2","title":"AshGraphql.Resource.Info.show_field?/2","type":"function"},{"doc":"The graphql type of the resource","ref":"AshGraphql.Resource.Info.html#type/1","title":"AshGraphql.Resource.Info.type/1","type":"function"},{"doc":"Imported helpers for the graphql DSL section","ref":"AshGraphql.Resource.Helpers.html","title":"AshGraphql.Resource.Helpers","type":"module"},{"doc":"A list of a given type, idiomatic for those used to `absinthe` notation.","ref":"AshGraphql.Resource.Helpers.html#list_of/1","title":"AshGraphql.Resource.Helpers.list_of/1","type":"function"},{"doc":"A non nullable type, idiomatic for those used to `absinthe` notation.","ref":"AshGraphql.Resource.Helpers.html#non_null/1","title":"AshGraphql.Resource.Helpers.non_null/1","type":"function"},{"doc":"The entrypoint for adding graphql behavior to an Ash API","ref":"AshGraphql.Api.html","title":"AshGraphql.Api","type":"module"},{"doc":"#","ref":"AshGraphql.Api.html#module-dsl-documentation","title":"DSL Documentation - AshGraphql.Api","type":"module"},{"doc":"* graphql\n\n#","ref":"AshGraphql.Api.html#module-index","title":"Index - AshGraphql.Api","type":"module"},{"doc":"","ref":"AshGraphql.Api.html#module-docs","title":"Docs - AshGraphql.Api","type":"module"},{"doc":"Global configuration for graphql\n\n\n\n\nExamples:\n```\ngraphql do\n  authorize? false # To skip authorization for this API\nend\n\n```\n\n\n\n\n---\n\n* `:authorize?` (`t:boolean/0`) - Whether or not to perform authorization for this API The default value is `true`.\n\n* `:tracer` (`t:atom/0`) - A tracer to use to trace execution in the graphql. Will use `config :ash, :tracer` if it is set.\n\n* `:root_level_errors?` (`t:boolean/0`) - By default, mutation errors are shown in their result object's errors key, but this setting places those errors in the top level errors list The default value is `false`.\n\n* `:error_handler` - Set an MFA to intercept/handle any errors that are generated. The default value is `{AshGraphql.DefaultErrorHandler, :handle_error, []}`.\n\n* `:show_raised_errors?` (`t:boolean/0`) - For security purposes, if an error is *raised* then Ash simply shows a generic error. If you want to show those errors, set this to true. The default value is `false`.\n\n* `:debug?` (`t:boolean/0`) - Whether or not to log (extremely verbose) debug information The default value is `false`.","ref":"AshGraphql.Api.html#module-graphql","title":"graphql - AshGraphql.Api","type":"module"},{"doc":"","ref":"AshGraphql.Api.html#authorize?/1","title":"AshGraphql.Api.authorize?/1","type":"function"},{"doc":"","ref":"AshGraphql.Api.html#debug?/1","title":"AshGraphql.Api.debug?/1","type":"function"},{"doc":"","ref":"AshGraphql.Api.html#global_type_definitions/2","title":"AshGraphql.Api.global_type_definitions/2","type":"function"},{"doc":"","ref":"AshGraphql.Api.html#root_level_errors?/1","title":"AshGraphql.Api.root_level_errors?/1","type":"function"},{"doc":"","ref":"AshGraphql.Api.html#show_raised_errors?/1","title":"AshGraphql.Api.show_raised_errors?/1","type":"function"},{"doc":"Helper to extract context from its various locations","ref":"AshGraphql.ContextHelpers.html","title":"AshGraphql.ContextHelpers","type":"module"},{"doc":"","ref":"AshGraphql.ContextHelpers.html#get_context/1","title":"AshGraphql.ContextHelpers.get_context/1","type":"function"},{"doc":"Replaces any text in message or short_message with variables","ref":"AshGraphql.DefaultErrorHandler.html","title":"AshGraphql.DefaultErrorHandler","type":"module"},{"doc":"","ref":"AshGraphql.DefaultErrorHandler.html#handle_error/2","title":"AshGraphql.DefaultErrorHandler.handle_error/2","type":"function"},{"doc":"","ref":"AshGraphql.Error.html","title":"AshGraphql.Error","type":"protocol"},{"doc":"","ref":"AshGraphql.Error.html#to_error/1","title":"AshGraphql.Error.to_error/1","type":"function"},{"doc":"All the types that implement this protocol.","ref":"AshGraphql.Error.html#t:t/0","title":"AshGraphql.Error.t/0","type":"type"},{"doc":"Utilities for working with errors in custom resolvers.","ref":"AshGraphql.Errors.html","title":"AshGraphql.Errors","type":"module"},{"doc":"Transform an error or list of errors into the response for graphql.","ref":"AshGraphql.Errors.html#to_errors/3","title":"AshGraphql.Errors.to_errors/3","type":"function"},{"doc":"Automatically set up the GraphQL `actor` and `tenant`.\n\nAdding this plug to your pipeline will automatically set the `actor` and\n`tenant` if they were previously put there by `Ash.PlugHelpers.set_actor/2` or\n`Ash.PlugHelpers.set_tenant/2`.","ref":"AshGraphql.Plug.html","title":"AshGraphql.Plug","type":"module"},{"doc":"","ref":"AshGraphql.Plug.html#call/2","title":"AshGraphql.Plug.call/2","type":"function"},{"doc":"","ref":"AshGraphql.Plug.html#init/1","title":"AshGraphql.Plug.init/1","type":"function"},{"doc":"This Ash resource extension adds configuration for exposing a resource in a graphql.","ref":"AshGraphql.Resource.html","title":"AshGraphql.Resource","type":"module"},{"doc":"#","ref":"AshGraphql.Resource.html#module-dsl-documentation","title":"DSL Documentation - AshGraphql.Resource","type":"module"},{"doc":"* graphql\n    * queries\n      * get\n      * read_one\n      * list\n      * action\n    * mutations\n      * create\n      * update\n      * destroy\n      * action\n    * managed_relationships\n      * managed_relationship\n\n#","ref":"AshGraphql.Resource.html#module-index","title":"Index - AshGraphql.Resource","type":"module"},{"doc":"","ref":"AshGraphql.Resource.html#module-docs","title":"Docs - AshGraphql.Resource","type":"module"},{"doc":"Configuration for a given resource in graphql\n\n\n * [queries](#module-queries)\n   * get\n   * read_one\n   * list\n   * action\n * [mutations](#module-mutations)\n   * create\n   * update\n   * destroy\n   * action\n * [managed_relationships](#module-managed_relationships)\n   * managed_relationship\n\nExamples:\n```\ngraphql do\n  type :post\n\n  queries do\n    get :get_post, :read\n    list :list_posts, :read\n  end\n\n  mutations do\n    create :create_post, :create\n    update :update_post, :update\n    destroy :destroy_post, :destroy\n  end\nend\n\n```\n\n\nImports:\n\n* `AshGraphql.Resource.Helpers`\n\n---\n\n* `:type` (`t:atom/0`) - Required. The type to use for this entity in the graphql schema\n\n* `:derive_filter?` (`t:boolean/0`) - Set to false to disable the automatic generation of a filter input for read actions. The default value is `true`.\n\n* `:derive_sort?` (`t:boolean/0`) - Set to false to disable the automatic generation of a sort input for read actions. The default value is `true`.\n\n* `:encode_primary_key?` (`t:boolean/0`) - For resources with composite primary keys, or primary keys not called `:id`, this will cause the id to be encoded as a single `id` attribute, both in the representation of the resource and in get requests The default value is `true`.\n\n* `:relationships` (list of `t:atom/0`) - A list of relationships to include on the created type. Defaults to all public relationships where the destination defines a graphql type.\n\n* `:field_names` (`t:keyword/0`) - A keyword list of name overrides for attributes.\n\n* `:hide_fields` (list of `t:atom/0`) - A list of attributes to hide from the api\n\n* `:argument_names` (`t:keyword/0`) - A nested keyword list of action names, to argument name remappings. i.e `create: [arg_name: :new_name]`\n\n* `:keyset_field` (`t:atom/0`) - If set, the keyset will be displayed on all read actions in this field.  \n  It will always be `nil` unless at least one of the read actions on a resource uses keyset pagination.\n  It will also be nil on any mutation results.\n\n* `:attribute_types` (`t:keyword/0`) - A keyword list of type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.\n\n* `:attribute_input_types` (`t:keyword/0`) - A keyword list of input type overrides for attributes. The type overrides should refer to types available in the graphql (absinthe) schema. `list_of/1` and `non_null/1` helpers can be used.\n\n* `:primary_key_delimiter` (`t:String.t/0`) - If a composite primary key exists, this can be set to determine delimiter used in the `id` field value. The default value is `\"~\"`.\n\n* `:depth_limit` (`t:integer/0`) - A simple way to prevent massive queries.\n\n* `:generate_object?` (`t:boolean/0`) - Whether or not to create the GraphQL object, this allows you to manually create the GraphQL object. The default value is `true`.\n\n* `:filterable_fields` (list of `t:atom/0`) - A list of fields that are allowed to be filtered on. Defaults to all filterable fields for which a GraphQL type can be created.\n\n\n\n\n\n#","ref":"AshGraphql.Resource.html#module-graphql","title":"graphql - AshGraphql.Resource","type":"module"},{"doc":"Queries (read actions) to expose for the resource.\n\n\n * [get](#module-get)\n * [read_one](#module-read_one)\n * [list](#module-list)\n * [action](#module-action)\n\nExamples:\n```\nqueries do\n  get :get_post, :read\n  read_one :current_user, :current_user\n  list :list_posts, :read\nend\n\n```\n\n\n\n\n---\n\n\n\n##","ref":"AshGraphql.Resource.html#module-queries","title":"queries - AshGraphql.Resource","type":"module"},{"doc":"A query to fetch a record by primary key\n\n\n\nExamples:\n```\nget :get_post, :read\n```\n\n\n* `:identity` (`t:atom/0`) - The identity to use for looking up the record. Pass `false` to not use an identity.\n\n* `:allow_nil?` (`t:boolean/0`) - Whether or not the action can return nil. The default value is `true`.\n\n* `:modify_resolution` - An MFA that will be called with the resolution, the query, and the result of the action as the first three arguments (followed by the arguments in the mfa).\n  Must return a new absinthe resolution. This can be used to implement things like setting cookies based on resource actions. A method of using resolution context\n  for that is documented here: https://hexdocs.pm/absinthe_plug/Absinthe.Plug.html#module-before-send  \n  *Important* if you are modifying the context, then you should also set `as_mutation?` to true and represent\n  this in your graphql as a mutation. See `as_mutation?` for more.\n\n* `:name` (`t:atom/0`) - The name to use for the query. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the query.\n\n* `:type_name` (`t:atom/0`) - Override the type name returned by this query. Must be set if the read action has `metadata`.  \n  To ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\n  To show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\n  includes the additional fields.\n\n* `:metadata_names` (`t:keyword/0`) - Name overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:metadata_types` (`t:keyword/0`) - Type overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:show_metadata` (list of `t:atom/0`) - The metadata attributes to show. Defaults to all.\n\n* `:as_mutation?` (`t:boolean/0`) - Places the query in the `mutations` key instead. The use cases for this are likely very minimal.  \n  If you have a query that needs to modify the graphql context using `modify_resolution`, then you\n  should likely set this as well. A simple example might be a `log_in`, which could be a read\n  action on the user that accepts an email/password, and should then set some context in the graphql\n  inside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\n  for more on setting the session or a cookie with an auth token. The default value is `false`.\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-get","title":"get - AshGraphql.Resource","type":"module"},{"doc":"A query to fetch a record\n\n\n\nExamples:\n```\nread_one :current_user, :current_user\n```\n\n\n* `:allow_nil?` (`t:boolean/0`) - Whether or not the action can return nil. The default value is `true`.\n\n* `:name` (`t:atom/0`) - The name to use for the query. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the query.\n\n* `:type_name` (`t:atom/0`) - Override the type name returned by this query. Must be set if the read action has `metadata`.  \n  To ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\n  To show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\n  includes the additional fields.\n\n* `:metadata_names` (`t:keyword/0`) - Name overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:metadata_types` (`t:keyword/0`) - Type overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:show_metadata` (list of `t:atom/0`) - The metadata attributes to show. Defaults to all.\n\n* `:as_mutation?` (`t:boolean/0`) - Places the query in the `mutations` key instead. The use cases for this are likely very minimal.  \n  If you have a query that needs to modify the graphql context using `modify_resolution`, then you\n  should likely set this as well. A simple example might be a `log_in`, which could be a read\n  action on the user that accepts an email/password, and should then set some context in the graphql\n  inside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\n  for more on setting the session or a cookie with an auth token. The default value is `false`.\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-read_one","title":"read_one - AshGraphql.Resource","type":"module"},{"doc":"A query to fetch a list of records\n\n\n\nExamples:\n```\nlist :list_posts, :read\n```\n```\nlist :list_posts_paginated, :read, relay?: true\n```\n\n\n* `:relay?` (`t:boolean/0`) - If true, the graphql queries/resolvers for this resource will be built to honor the [relay specification](https://relay.dev/graphql/connections.htm).  \n  The two changes that are made currently are:  \n  * the type for the resource will implement the `Node` interface\n  * pagination over that resource will behave as a Connection. The default value is `false`.\n\n* `:name` (`t:atom/0`) - The name to use for the query. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the query.\n\n* `:type_name` (`t:atom/0`) - Override the type name returned by this query. Must be set if the read action has `metadata`.  \n  To ignore any action metadata, set this to the same type the resource uses, or set `show_metadata` to `[]`.\n  To show metadata in the response, choose a new name here, like `:user_with_token` to get a response type that\n  includes the additional fields.\n\n* `:metadata_names` (`t:keyword/0`) - Name overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:metadata_types` (`t:keyword/0`) - Type overrides for metadata fields on the read action. The default value is `[]`.\n\n* `:show_metadata` (list of `t:atom/0`) - The metadata attributes to show. Defaults to all.\n\n* `:as_mutation?` (`t:boolean/0`) - Places the query in the `mutations` key instead. The use cases for this are likely very minimal.  \n  If you have a query that needs to modify the graphql context using `modify_resolution`, then you\n  should likely set this as well. A simple example might be a `log_in`, which could be a read\n  action on the user that accepts an email/password, and should then set some context in the graphql\n  inside of `modify_resolution`. Once in the context, you can see the guide referenced in `modify_resolution`\n  for more on setting the session or a cookie with an auth token. The default value is `false`.\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-list","title":"list - AshGraphql.Resource","type":"module"},{"doc":"Runs a generic action\n\n\n\nExamples:\n```\naction :check_status, :check_status\n```\n\n\n* `:name` (`t:atom/0`) - The name to use for the query. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the query.\n\n\n\n\n\n\n\n\n\n#","ref":"AshGraphql.Resource.html#module-action","title":"action - AshGraphql.Resource","type":"module"},{"doc":"Mutations (create/update/destroy actions) to expose for the resource.\n\n\n * [create](#module-create)\n * [update](#module-update)\n * [destroy](#module-destroy)\n * [action](#module-action)\n\nExamples:\n```\nmutations do\n  create :create_post, :create\n  update :update_post, :update\n  destroy :destroy_post, :destroy\nend\n\n```\n\n\n\n\n---\n\n\n\n##","ref":"AshGraphql.Resource.html#module-mutations","title":"mutations - AshGraphql.Resource","type":"module"},{"doc":"A mutation to create a record\n\n\n\nExamples:\n```\ncreate :create_post, :create\n```\n\n\n* `:name` (`t:atom/0`) - The name to use for the mutation. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the mutation.\n\n* `:upsert?` (`t:boolean/0`) - Whether or not to use the `upsert?: true` option when calling `YourApi.create/2`. The default value is `false`.\n\n* `:upsert_identity` (`t:atom/0`) - Which identity to use for the upsert The default value is `false`.\n\n* `:modify_resolution` - An MFA that will be called with the resolution, the changeset, and the result of the action as the first three arguments (followed by the arguments in the mfa).\n  Must return a new absinthe resolution. This can be used to implement things like setting cookies based on resource actions. A method of using resolution context\n  for that is documented here: https://hexdocs.pm/absinthe_plug/Absinthe.Plug.html#module-before-send\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-create","title":"create - AshGraphql.Resource","type":"module"},{"doc":"A mutation to update a record\n\n\n\nExamples:\n```\nupdate :update_post, :update\n```\n\n\n* `:name` (`t:atom/0`) - The name to use for the mutation. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the mutation.\n\n* `:identity` (`t:atom/0`) - The identity to use to fetch the record to be updated.  \n  If no identity is required (e.g for a read action that already knows how to fetch the item to be updated), use `false`.\n\n* `:read_action` (`t:atom/0`) - The read action to use to fetch the record to be updated. Defaults to the primary read action.\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-update","title":"update - AshGraphql.Resource","type":"module"},{"doc":"A mutation to destroy a record\n\n\n\nExamples:\n```\ndestroy :destroy_post, :destroy\n```\n\n\n* `:name` (`t:atom/0`) - The name to use for the mutation. The default value is `:get`.\n\n* `:action` (`t:atom/0`) - Required. The action to use for the mutation.\n\n* `:read_action` (`t:atom/0`) - The read action to use to fetch the record to be destroyed. Defaults to the primary read action.\n\n* `:identity` (`t:atom/0`) - The identity to use to fetch the record to be destroyed.\n  If no identity is required (e.g for a read action that already knows how to fetch the item to be updated), use `false`.\n\n\n\n\n\n\n##","ref":"AshGraphql.Resource.html#module-destroy","title":"destroy - AshGraphql.Resource","type":"module"},{"doc":"Generates input objects for `manage_relationship` arguments on resource actions.\n\n\n * [managed_relationship](#module-managed_relationship)\n\nExamples:\n```\nmanaged_relationships do\n  manage_relationship :create_post, :comments\nend\n\n```\n\n\n\n\n---\n\n* `:auto?` (`t:boolean/0`) - Automatically derive types for all arguments that have a `manage_relationship` call change.\n\n\n\n##","ref":"AshGraphql.Resource.html#module-managed_relationships","title":"managed_relationships - AshGraphql.Resource","type":"module"},{"doc":"Instructs ash_graphql that a given argument with a `manage_relationship` change should have its input objects derived automatically from the potential actions to be called.\n\nFor example, given an action like:\n\n```elixir\nactions do\n  create :create do\n    argument :comments, {:array, :map}\n\n    change manage_relationship(:comments, type: :direct_control) #  _ _ _input`  \n  Because multiple actions could potentially be managing the same relationship, it isn't suficcient to\n  default to something like ` _ _input`. Additionally, Ash doesn't expose resource\n  action names by default, meaning that there is no automatic way to ensure that all\n  of these have a default name that will always be unique. If you have multiple actions of the same\n  type that manage a relationship with an argument of the same name, you will get a compile-time error.\n\n* `:types` (`t:term/0`) - A keyword list of field names to their graphql type identifiers.  \n  Since managed relationships can ultimately call multiple actions, there is the possibility\n  of field type conflicts. Use this to determine the type of fields and remove the conflict warnings.  \n  For `non_null` use `{:non_null, type}`, and for a list, use `{:array, type}`, for example:  \n  `{:non_null, {:array, {:non_null, :string}}}` for a non null list of non null strings.  \n  To *remove* a key from the input object, simply pass `nil` as the type.","ref":"AshGraphql.Resource.html#module-managed_relationship","title":"managed_relationship - AshGraphql.Resource","type":"module"},{"doc":"","ref":"AshGraphql.Resource.html#decode_primary_key/2","title":"AshGraphql.Resource.decode_primary_key/2","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#encode_primary_key/1","title":"AshGraphql.Resource.encode_primary_key/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#enum_definitions/4","title":"AshGraphql.Resource.enum_definitions/4","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#generate_object?/1","title":"AshGraphql.Resource.generate_object?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#is_node_type/1","title":"AshGraphql.Resource.is_node_type/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#managed_relationships/1","title":"AshGraphql.Resource.managed_relationships/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#map_definitions/3","title":"AshGraphql.Resource.map_definitions/3","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#mutations/1","title":"AshGraphql.Resource.mutations/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#no_graphql_types/2","title":"AshGraphql.Resource.no_graphql_types/2","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#primary_key_delimiter/1","title":"AshGraphql.Resource.primary_key_delimiter/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#queries/1","title":"AshGraphql.Resource.queries/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#query_type_definitions/3","title":"AshGraphql.Resource.query_type_definitions/3","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#ref/1","title":"AshGraphql.Resource.ref/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#type/1","title":"AshGraphql.Resource.type/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#type_definition/3","title":"AshGraphql.Resource.type_definition/3","type":"function"},{"doc":"","ref":"AshGraphql.Resource.html#union_definitions/3","title":"AshGraphql.Resource.union_definitions/3","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Action.html","title":"AshGraphql.Resource.Action","type":"module"},{"doc":"Represents a managed relationship configuration on a mutation","ref":"AshGraphql.Resource.ManagedRelationship.html","title":"AshGraphql.Resource.ManagedRelationship","type":"module"},{"doc":"","ref":"AshGraphql.Resource.ManagedRelationship.html#schema/0","title":"AshGraphql.Resource.ManagedRelationship.schema/0","type":"function"},{"doc":"Represents a configured mutation on a resource","ref":"AshGraphql.Resource.Mutation.html","title":"AshGraphql.Resource.Mutation","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Mutation.html#create_schema/0","title":"AshGraphql.Resource.Mutation.create_schema/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Mutation.html#destroy_schema/0","title":"AshGraphql.Resource.Mutation.destroy_schema/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Mutation.html#update_schema/0","title":"AshGraphql.Resource.Mutation.update_schema/0","type":"function"},{"doc":"Represents a configured query on a resource","ref":"AshGraphql.Resource.Query.html","title":"AshGraphql.Resource.Query","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Query.html#get_schema/0","title":"AshGraphql.Resource.Query.get_schema/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Query.html#list_schema/0","title":"AshGraphql.Resource.Query.list_schema/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Query.html#read_one_schema/0","title":"AshGraphql.Resource.Query.read_one_schema/0","type":"function"},{"doc":"Set the computation of resolving union types as functions","ref":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.html","title":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.html#after?/1","title":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.after?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.html#after_compile?/0","title":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.after_compile?/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.html#before?/1","title":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.before?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.html#transform/1","title":"AshGraphql.Resource.Transformers.AddUnionTypeResolvers.transform/1","type":"function"},{"doc":"Ensures that all relay queries configure keyset pagination","ref":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.html","title":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.html#after?/1","title":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.after?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.html#after_compile?/0","title":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.after_compile?/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.html#before?/1","title":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.before?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.html#transform/1","title":"AshGraphql.Resource.Transformers.RequireKeysetForRelayQueries.transform/1","type":"function"},{"doc":"Ensures that the resource has a primary key called `id`","ref":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.html","title":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.html#after?/1","title":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.after?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.html#after_compile?/0","title":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.after_compile?/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.html#before?/1","title":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.before?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.html#transform/1","title":"AshGraphql.Resource.Transformers.RequirePkeyDelimiter.transform/1","type":"function"},{"doc":"Ensures that all referenced actiosn exist","ref":"AshGraphql.Resource.Transformers.ValidateActions.html","title":"AshGraphql.Resource.Transformers.ValidateActions","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateActions.html#after?/1","title":"AshGraphql.Resource.Transformers.ValidateActions.after?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateActions.html#after_compile?/0","title":"AshGraphql.Resource.Transformers.ValidateActions.after_compile?/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateActions.html#before?/1","title":"AshGraphql.Resource.Transformers.ValidateActions.before?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateActions.html#transform/1","title":"AshGraphql.Resource.Transformers.ValidateActions.transform/1","type":"function"},{"doc":"Ensures that all field names are valid or remapped to something valid exist","ref":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.html","title":"AshGraphql.Resource.Transformers.ValidateCompatibleNames","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.html#after?/1","title":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.after?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.html#after_compile?/0","title":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.after_compile?/0","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.html#before?/1","title":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.before?/1","type":"function"},{"doc":"","ref":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.html#transform/1","title":"AshGraphql.Resource.Transformers.ValidateCompatibleNames.transform/1","type":"function"},{"doc":"Ensures that queries for actions with metadata have a type set","ref":"AshGraphql.Resource.Verifiers.VerifyQueryMetadata.html","title":"AshGraphql.Resource.Verifiers.VerifyQueryMetadata","type":"module"},{"doc":"","ref":"AshGraphql.Resource.Verifiers.VerifyQueryMetadata.html#verify/1","title":"AshGraphql.Resource.Verifiers.VerifyQueryMetadata.verify/1","type":"function"},{"doc":"Helpers for working with absinthe subscriptions","ref":"AshGraphql.Subscription.html","title":"AshGraphql.Subscription","type":"module"},{"doc":"Produce a query that will load the correct data for a subscription.","ref":"AshGraphql.Subscription.html#query_for_subscription/3","title":"AshGraphql.Subscription.query_for_subscription/3","type":"function"},{"doc":"The Json scalar type allows arbitrary JSON values to be passed in and out.","ref":"AshGraphql.Types.JSON.html","title":"AshGraphql.Types.JSON","type":"module"},{"doc":"","ref":"AshGraphql.Types.JSON.html#decode/1","title":"AshGraphql.Types.JSON.decode/1","type":"function"},{"doc":"","ref":"AshGraphql.Types.JSON.html#encode/1","title":"AshGraphql.Types.JSON.encode/1","type":"function"},{"doc":"The Json scalar type allows arbitrary JSON values to be passed in and out.","ref":"AshGraphql.Types.JSONString.html","title":"AshGraphql.Types.JSONString","type":"module"},{"doc":"","ref":"AshGraphql.Types.JSONString.html#decode/1","title":"AshGraphql.Types.JSONString.decode/1","type":"function"},{"doc":"","ref":"AshGraphql.Types.JSONString.html#encode/1","title":"AshGraphql.Types.JSONString.encode/1","type":"function"},{"doc":"# Monitoring\n\nPlease read [the Ash monitoring guide](https://hexdocs.pm/ash/monitoring.html) for more information. Here we simply cover the additional traces & telemetry events that we publish from this extension.\n\nA tracer can be configured in the api. It will fallback to the global tracer configuration `config :ash, :tracer, Tracer`\n\n```elixir\ngraphql do\n  trace MyApp.Tracer\nend\n```","ref":"monitoring.html","title":"Monitoring","type":"extras"},{"doc":"Each graphql resolver, and batch resolution of the underlying data loader, will produce a span with an appropriate name. We also set a `source: :graphql` metadata if you want to filter them out or annotate them in some way.","ref":"monitoring.html#traces","title":"Traces - Monitoring","type":"extras"},{"doc":"AshGraphql emits the following telemetry events, suffixed with `:start` and `:stop`. Start events have `system_time` measurements, and stop events have `system_time` and `duration` measurements. All times will be in the native time unit.\n\n- `[:ash,  , :gql_mutation]` - The execution of a mutation. Use `resource_short_name` and `mutation` (or `action`) metadata to break down measurements.\n- `[:ash,  , :gql_query]` - The execution of a mutation. Use `resource_short_name` and `query` (or `action`) metadata to break down measurements.\n\n- `[:ash,  , :gql_relationship]` - The resolution of a relationship. Use `resource_short_name` and `relationship` metadata to break down measurements.\n\n- `[:ash,  , :gql_calculation]` - The resolution of a calculation. Use `resource_short_name` and `calculation` metadata to break down measurements.\n\n- `[:ash,  , :gql_relationship_batch]` - The resolution of a batch of relationships by the data loader. Use `resource_short_name` and `relationship` metadata to break down measurements.\n\n- `[:ash,  , :gql_calculation_batch]` - The resolution of a batch of calculations by the data loader. Use `resource_short_name` and `calculation` metadata to break down measurements.","ref":"monitoring.html#telemetry","title":"Telemetry - Monitoring","type":"extras"},{"doc":"# Authorize with GraphQL\n\nAshGraphql uses three special keys in the `absinthe` context:\n\n* `:actor` - the current actor, to be used for authorization/preparations/changes\n* `:tenant` - a tenant when using [multitenancy](https://ash-hq.org/docs/guides/ash/latest/topics/multitenancy.md).\n* `:ash_context` - a map of arbitrary context to be passed into the changeset/query. Accessible via `changeset.context` and `query.context`\n\nBy default, `authorize?` in the api is set to true. To disable authorization for a given API in graphql, use:\n\n```elixir\ngraphql do\n  authorize? false\nend\n```\n\nIf you are doing authorization, you'll need to provide an `actor`.\n\nTo set the `actor` for authorization, you'll need to add an `actor` key to the\nabsinthe context. Typically, you would have a plug that fetches the current user\nand uses `Ash.PlugHelpers.set_actor/2` to set the actor in the `conn` (likewise\nwith `Ash.PlugHelpers.set_tenant/2`).\n\nJust add `AshGraphql.Plug` somewhere _after_ that in the pipeline and the your\nGraphQL APIs will have the correct authorization.\n\n```elixir\ndefmodule MyAppWeb.Router do\n  pipeline :api do\n    # ...\n    plug :get_actor_from_token\n    plug AshGraphql.Plug\n  end\n\n  scope \"/\" do\n    forward \"/gql\", Absinthe.Plug, schema: YourSchema\n\n    forward \"/playground\",\n          Absinthe.Plug.GraphiQL,\n          schema: YourSchema,\n          interface: :playground\n  end\n\n  def get_actor_from_token(conn, _opts) do\n     with [\"\"   token]   set_actor(user)\n    else\n    _ -> conn\n    end\n  end\nend\n```","ref":"authorize-with-graphql.html","title":"Authorize With Graphql","type":"extras"},{"doc":"By default, unauthorized requests simply return `forbidden` in the message. If you prefer to show policy breakdowns in your GraphQL errors, you can set the config option:\n\n```elixir\nconfig :ash_graphql, :policies, show_policy_breakdowns?: true\n```\n\n```json\n{\n  \"data\": {\n    \"attendanceRecords\": null\n  },\n  \"errors\": [\n    {\n      \"code\": \"forbidden\",\n      \"fields\": [],\n      \"locations\": [\n        {\n          \"column\": 3,\n          \"line\": 2\n        }\n      ],\n      \"message\": \"MyApp.Authentication.User.read\\n\\n\\n\\n\\nPolicy Breakdown\\n  Policy | ⛔:\\n    forbid unless: actor is active | ✓ | ⬇    \\n    authorize if: actor is Executive | ✘ | ⬇\",\n      \"path\": [\n        \"attendanceRecords\"\n      ],\n      \"short_message\": \"forbidden\",\n      \"vars\": {}\n    }\n  ]\n}\n```\n\nBe careful, as this can be an attack vector in some systems (i.e \"here is exactly what you need to make true to do what you want to do\").","ref":"authorize-with-graphql.html#policy-breakdowns","title":"Policy Breakdowns - Authorize With Graphql","type":"extras"},{"doc":"# Handling Errors\n\nThere are various options that can be set on the Api module to determine how errors behave and/or are shown in the GraphQL.","ref":"handle-errors.html","title":"Handle Errors","type":"extras"},{"doc":"For security purposes, if an error is *raised* as opposed to returned somewhere, the error is hidden. Set this to `true` in dev/test environments for an easier time debugging.\n\n```elixir\ngraphql do\n  show_raised_errors? true\nend\n\n# or it can be done in config\n# make sure you've set `otp_app` in your api, i.e use Ash.Api, otp_app: :my_app\n\nconfig :my_app, YourApi, [\n  graphql: [\n    show_raised_errors?: true\n  ]\n]\n```","ref":"handle-errors.html#showing-raised-errors","title":"Showing raised errors - Handle Errors","type":"extras"},{"doc":"By default, action errors are simply shown in the `errors` field for mutations. Set this to `true` to return them as root level errors instead.\n\n```elixir\ngraphql do\n  root_level_errors? true\nend\n```","ref":"handle-errors.html#root-level-errors","title":"Root level errors - Handle Errors","type":"extras"},{"doc":"Setting an error handler allows you to use things like `gettext` to translate errors and/or modify errors in some way. This error handler will take the error object to be returned, and the context. See the [absinthe docs](https://hexdocs.pm/absinthe/context-and-authentication.html#context-and-plugs) for adding to the absinthe context (i.e for setting a locale).\n\n```elixir\ngraphql do\n  error_handler {MyApp.GraphqlErrorHandler, :handle_error, []}\nend\n```\n\nKeep in mind, that you will want to ensure that any custom error handler you add performs the logic to replace variables in error messages. \n\nThis is what the default error handler looks like, for example:\n\n```elixir\ndefmodule AshGraphql.DefaultErrorHandler do\n  @moduledoc \"Replaces any text in message or short_message with variables\"\n\n  def handle_error(\n        %{message: message, short_message: short_message, vars: vars} = error,\n        _context\n      ) do\n    %{\n      error\n      | message: replace_vars(message, vars),\n        short_message: replace_vars(short_message, vars)\n    }\n  end\n\n  def handle_error(other, _), do: other\n\n  defp replace_vars(string, vars) do\n    vars =\n      if is_map(vars) do\n        vars\n      else\n        List.wrap(vars)\n      end\n\n    Enum.reduce(vars, string, fn {key, value}, acc ->\n      if String.contains?(acc, \"%{#{key}}\") do\n        String.replace(acc, \"%{#{key}}\", to_string(value))\n      else\n        acc\n      end\n    end)\n  end\nend\n```","ref":"handle-errors.html#error-handler","title":"Error Handler - Handle Errors","type":"extras"},{"doc":"# Use Enums with GraphQL","ref":"use-enums-with-graphql.html","title":"Use Enums With Graphql","type":"extras"},{"doc":"Enums are implemented automatically for any `atom` *attribute* (not arguments) with a `one_of` constraint. For example:\n\n```elixir\n# On the resource of type `:ticket`\nattribute :type, :atom do\n  constraints one_of: [:foo, :bar, :baz]\nend\n```\n\nThis would produce an enum called `:ticket_type`/`TicketType`.","ref":"use-enums-with-graphql.html#automatically-created-enums","title":"Automatically created enums - Use Enums With Graphql","type":"extras"},{"doc":"#","ref":"use-enums-with-graphql.html#custom-enums","title":"Custom enums - Use Enums With Graphql","type":"extras"},{"doc":"If you define an `Ash.Type.Enum`, that enum type can be used both in attributes *and* arguments. You will need to add `graphql_type/0` to your implementation. AshGraphql will ensure that a single type is defined for it, which will be reused across all occurrences. If an enum\ntype is referenced, but does not have `graphql_type/0` defined, it will\nbe treated as a string input.\n\nFor example:\n\n```elixir\ndefmodule AshPostgres.Test.Types.Status do\n  @moduledoc false\n  use Ash.Type.Enum, values: [:open, :closed]\n\n  def graphql_type, do: :ticket_status\n\n  # Optionally, remap the names used in GraphQL, for instance if you have a value like `:\"10\"`\n  # that value is not compatible with GraphQL\n\n  def graphql_rename_value(:\"10\"), do: :ten\n  def graphql_rename_value(value), do: value\nend\n\n```\n\n#","ref":"use-enums-with-graphql.html#using-ash-enum-types","title":"Using Ash Enum types - Use Enums With Graphql","type":"extras"},{"doc":"You can implement a custom enum by first adding the enum type to your absinthe schema (more [here](https://hexdocs.pm/absinthe/Absinthe.Type.Enum.html)). Then you can define a custom Ash type that refers to that absinthe enum type.\n\n```elixir\n# In your absinthe schema:\n\nenum :status do\n  value(:open, description: \"The post is open\")\n  value(:closed, description: \"The post is closed\")\nend\n```\n\n```elixir\n# Your custom Ash Type\ndefmodule AshGraphql.Test.Status do\n  use Ash.Type\n\n  @values [:open, :closed]\n  @string_values Enum.map(@values, &to_string/1)\n\n  def graphql_input_type(_), do: :status\n  def graphql_type(_), do: :status\n\n  @impl true\n  def storage_type, do: :string\n\n  @impl true\n  def cast_input(value, _) when value in @values do\n    {:ok, value}\n  end\n\n  def cast_input(value, _) when is_binary(value) do\n    value = String.downcase(value)\n\n    if value in @string_values do\n      {:ok, String.to_existing_atom(value)}\n    else\n      :error\n    end\n  end\n\n  @impl true\n  def cast_stored(value, _) when value in @values do\n    {:ok, value}\n  end\n\n  def cast_stored(value, _) when value in @string_values do\n    {:ok, String.to_existing_atom(value)}\n  rescue\n    ArgumentError ->\n      :error\n  end\n\n  @impl true\n  def dump_to_native(value, _) when is_atom(value) do\n    {:ok, to_string(value)}\n  end\n\n  def dump_to_native(_, _), do: :error\nend\n```","ref":"use-enums-with-graphql.html#using-custom-absinthe-types","title":"Using custom absinthe types - Use Enums With Graphql","type":"extras"},{"doc":"# Use JSON with GraphQL\n\nAshGraphql provides two JSON types that may be used. They are the same except for how the type is serialized in responses.\n\n- `:json_string` - serializes the json to a string, e.g `\"{\\\"foo\\\":1}\"`\n- `:json` - leaves the json as an object, e.g `{foo: 1}`\n\nBy default, `:json_string` is used. The configuration for this is (uncharacteristically) placed in application config, for example:\n\n```elixir\nconfig :ash_graphql, :json_type, :json\n```","ref":"use-json-with-graphql.html","title":"Use Json With Graphql","type":"extras"},{"doc":"# Use Unions with GraphQL\n\nBy default, if a union is used in your resource in line, it will get a nice type generated for it based on the \nresource/key name. Often, you'll want to define a union using `Ash.Type.NewType`. For example:\n\n```elixir\ndefmodule MyApp.Armor do\n  use Ash.Type.NewType, subtype_of: :union, constraints: [\n    types: [\n      plate: [\n        # This is an embedded resource, with its own fields\n        type: MyApp.Armor.Plate\n      ],\n      chain_mail: [\n        # And so is this\n        type: MyApp.Armor.ChainMail\n      ],\n      custom: [\n        type: :string\n      ]\n    ]\n  ]\n\n  # Add this to define the union in ash_graphql\n  def graphql_type(_), do: :armor\nend\n```\n\nBy default, the type you would get for this on input and output would look something like this:\n\n```\ntype Armor = {plate: {value: Plate}} | {chain_mail: {value: ChainMail}} | {custom: {value: String}}\n```\n\nWe do this by default to solve for potentially ambiguous types. An example of this might be if you had multiple different types of strings in a union, and you wanted the client to be able to tell exactly which type of string they'd been given. i.e `{social: {value: \"555-55-5555\"}} | {phone_number: {value: \"555-5555\"}}`.\n\nHowever, you can clean the type in cases where you have no such conflicts by by providing\n\n```elixir\n# Put anything in here that does not need to be named/nested with `{type_name: {value: value}}`\ndef graphql_unnested_unions(_constraints), do: [:plate, :chain_mail]\n```\n\nWhich, in this case, would yield:\n\n```\ntype Armor = Plate | ChainMail | {custom: {value: String}}\n```","ref":"use-unions-with-graphql.html","title":"Use Unions With Graphql","type":"extras"},{"doc":"# GraphQL Query Generation","ref":"graphql-generation.html","title":"Graphql Generation","type":"extras"},{"doc":"Following where we left off from [Getting Started with GraphQL](/documentation/tutorials/getting-started-with-graphql.md), we'll explore what the GraphQL\nrequests and responses look like for different queries defined with the AshGraphql DSL.\n\n```elixir\ndefmodule Helpdesk.Support.Ticket do\n  use Ash.Resource,\n    ...,\n    extensions: [\n      AshGraphql.Resource\n    ]\n\n  attributes do\n    # Add an autogenerated UUID primary key called `:id`.\n    uuid_primary_key :id\n\n    # Add a string type attribute called `:subject`\n    attribute :subject, :string\n  end\n\n  actions do\n    # Add a set of simple actions. You'll customize these later.\n    defaults [:read, :update, :destroy]\n  end\n\n  graphql do\n    type :ticket\n\n    queries do\n      # create a field called `get_ticket` that uses the `read` read action to fetch a single ticket\n      get :get_ticket, :read \n    end\n  end\nend\n```\n\nFor the `get_ticket` query defined above, the corresponding GraphQL would look like this:\n\n```graphql\nquery($id: ID!) {\n  getTicket(id: $id) {\n    id\n    subject\n  }\n}\n```\n\nAnd the response would look similar to this:\n\n```json\n{\n  \"data\": {\n    \"getTicket\": {\n      \"id\": \"\",\n      \"subject\": \"\"\n    }\n  }\n}\n```\n\nLet's look at an example of querying a list of things.\n\n```elixir\n  graphql do\n    type :ticket\n\n    queries do\n      # create a field called `get_ticket` that uses the `read` read action to fetch a single ticket\n      get :get_ticket, :read \n\n      # create a field called `list_tickets` that uses the `read` read action to fetch a list of tickets\n      list :list_tickets, :read \n    end\n  end\n```\n\nThis time, we've added `list :list_tickets, :read`, to generate a GraphQL query for listing tickets.\nThe request would look something like this:\n\n```graphql\nquery {\n  listTickets {\n    id\n    subject\n  }\n}\n```\n\nAnd the response would look similar to this:\n\n```json\n{\n  \"data\": {\n    \"listTickets\": [\n      {\n        \"id\": \"\",\n        \"subject\": \"\"\n      }\n    ]\n  }\n}\n```","ref":"graphql-generation.html#fetch-data-by-id","title":"Fetch Data by ID - Graphql Generation","type":"extras"},{"doc":"Now, let's say we want to add query parameters to `listTickets`. How do we do that?\nConsider `list :list_tickets, :read` and the `actions` section:\n\n```elixir\n  actions do\n    # Add a set of simple actions. You'll customize these later.\n    defaults [:read, :update, :destroy]\n  end\n\n  graphql do\n    type :ticket\n\n    queries do\n      # create a field called `list_tickets` that uses the `read` read action to fetch a list of tickets\n      list :list_tickets, :read \n    end\n  end\n```\n\nThe second argument to `list :list_tickets, :read` is the action that will be called when the query is run.\nIn the current example, the action is `:read`, which is the generic Read action.\nLet's create a custom action in order to define query parameters for the `listTickets` query.\n\nWe'll call this action `:query_tickets`:\n\n```elixir\n  actions do\n    defaults [:read, :update, :destroy]\n    \n    read :query_tickets do\n      argument :representative_id, :uuid\n\n      filter(\n        expr do\n          is_nil(^arg(:representative_id)) or representative_id == ^arg(:representative_id)\n        end\n      )\n    end\n  end\n\n  graphql do\n    type :ticket\n\n    queries do\n      # create a field called `list_tickets` that uses the `:query_tickets` read action to fetch a list of tickets\n      list :list_tickets, :query_tickets\n    end\n  end\n```\n\nIn the `graphql` section, the `list/2` call has been changed, replacing the `:read` action with `:query_tickets`.\n\nThe GraphQL request would look something like this:\n\n```graphql\nquery($representative_id: ID) {\n  list_tickets(representative_id: $representative_id) {\n    id\n    representative_id\n    subject\n  }\n}\n```","ref":"graphql-generation.html#filter-data-with-arguments","title":"Filter Data With Arguments - Graphql Generation","type":"extras"},{"doc":"Now, let's look at how to create a ticket by using a GraphQL mutation.\n\nLet's say you have a Resource that defines an enum-like attribute:\n\n```elixir\ndefmodule Helpdesk.Support.Ticket do\n  use Ash.Resource,\n    ...,\n    extensions: [\n      AshGraphql.Resource\n    ]\n\n\n  attributes do\n    uuid_primary_key :id\n    attribute :subject, :string\n    attribute :status, :atom, constraints: [one_of: [:open, :closed]]\n  end\n\n  actions do\n    defaults [:create, :read, :update, :destroy]\n  end\n\n  graphql do\n    type :ticket\n\n    queries do\n      get :get_ticket, :read \n    end\n    \n    mutations do\n      create :create_ticket, :create\n    end\n  end\nend\n```\n\nAbove, the following changes have been added:\n\n1. In the `attributes` section, the `:status` attribute has been added.\n2. In the `actions` section, the `:create` action has been added.\n3. The `:create_ticket` mutation has been defined in the new `graphql.mutations` section.\n\nThe `:status` attribute is an enum that is constrained to the values `[:open, :closed]`.\nWhen used in conjunction with AshGraphql, a GraphQL enum type called `TicketStatus` will be generated for this attribute.\nThe possible GraphQL values for `TicketStatus` are `OPEN` and `CLOSED`.\nSee [Use Enums with GraphQL](/documentation/guides/use-enums-with-graphql.md) for more information.\n\nWe can now create a ticket with the `createTicket` mutation:\n\n```graphql\nmutation($input: CreateTicketInput!) {\n  createTicket(input: $input) {\n    result {\n      id\n      subject\n      status\n    }\n    errors {\n      code\n      fields\n      message\n      shortMessage\n      vars\n    }\n  }\n}\n```\n\n**Note**\n\n- The resulting ticket data is wrapped in AshGraphql's `result` object.\n- Validation errors are wrapped in a list of error objects under `errors`, also specified in the query.\n  AshGraphql does this by default instead of exposing errors in GraphQL's standard `errors` array.\n  This behavior can be changed by setting `root_level_errors? true` in the `graphql` section\n  of your Ash API module:\n\n  ```elixir\n  defmodule Helpdesk.Support do\n    use Ash.Api, extensions: [AshGraphql.Api]\n\n    graphql do\n      root_level_errors? true\n    end\n  end\n  ```\n\nIf we were to run this mutation in a test, it would look something like this:\n\n```elixir\ninput = %{\n  subject: \"My Ticket\",\n  status: \"OPEN\"\n}\n\nresp_body =\n  post(conn, \"/api/graphql\", %{\n    query: query,\n    variables: %{input: input}\n  })\n  |> json_response(200)\n```\n\nNotice that the `status` attribute is set to `\"OPEN\"` and not `\"open\"`. It is important that the value of the `status` be uppercase.\nThis is required by GraphQL enums. AshGraphql will automatically convert the value to the correct case.\n\nThe response will look something like this:\n  \n  ```json\n  {\n    \"data\": {\n      \"createTicket\": {\n        \"result\": {\n          \"id\": \"b771e433-0979-4d07-a280-4d12373849aa\",\n          \"subject\": \"My Ticket\",\n          \"status\": \"OPEN\"\n        }\n      }\n    }\n  }\n  ```\n\nAgain, AshGraphql will automatically convert the `status` value from `:open` to `\"OPEN\"`.","ref":"graphql-generation.html#mutations-and-enums","title":"Mutations and Enums - Graphql Generation","type":"extras"},{"doc":"If you haven't already, please turn on the documentation tag for AshGraphql. Tags can be controlled\nat the top of the left navigation menu, under \"Including Libraries:\".\n\n- [Getting Started With GraphQL](/documentation/tutorials/getting-started-with-graphql.md)\n- `AshGraphql.Api`","ref":"graphql-generation.html#more-graphql-docs","title":"More GraphQL Docs - Graphql Generation","type":"extras"},{"doc":"# Getting Started With GraphQL","ref":"getting-started-with-graphql.html","title":"Getting Started With Graphql","type":"extras"},{"doc":"If you haven't already, read the [Ash Getting Started Guide](https://hexdocs.pm/ash/get-started.html). This assumes that you already have resources set up, and only gives you the steps to _add_ AshGraphql to your resources/apis.","ref":"getting-started-with-graphql.html#get-familiar-with-ash-resources","title":"Get familiar with Ash resources - Getting Started With Graphql","type":"extras"},{"doc":"```elixir\ndef deps()\n  [\n    ...\n    {:ash_graphql, \"~> 0.26.0\"}\n  ]\nend\n```","ref":"getting-started-with-graphql.html#bring-in-the-ash_graphql-dependency","title":"Bring in the ash_graphql dependency - Getting Started With Graphql","type":"extras"},{"doc":"in `config/config.exs`\n\n```elixir\nconfig :ash_graphql, :default_managed_relationship_type_name_template, :action_name\n```\n\nThis won't be necessary after the next major release, where this new configuration will be the default.","ref":"getting-started-with-graphql.html#add-some-backwards-compatibility-configuration","title":"Add some backwards compatibility configuration - Getting Started With Graphql","type":"extras"},{"doc":"Add the following to your API module. If you don't have one, be sure to start with the [Ash Getting Started Guide](https://hexdocs.pm/ash/get-started.html).\n\n```elixir\ndefmodule Helpdesk.Support do\n  use Ash.Api, extensions: [\n    AshGraphql.Api\n  ]\n\n  graphql do\n    authorize? false # Defaults to `true`, use this to disable authorization for the entire API (you probably only want this while prototyping)\n  end\n\n  ... \nend\n```","ref":"getting-started-with-graphql.html#add-the-api-extension","title":"Add the API Extension - Getting Started With Graphql","type":"extras"},{"doc":"Some example queries/mutations are shown below. If no queries/mutations are added, nothing will show up in the GraphQL API, so be sure to set one up if you want to try it out.\n\n```elixir\ndefmodule Helpdesk.Support.Ticket. do\n  use Ash.Resource,\n    ...,\n    extensions: [\n      AshGraphql.Resource\n    ]\n\n  graphql do\n    type :ticket\n\n    queries do\n      # Examples\n\n      # create a field called `get_ticket` that uses the `read` read action to fetch a single ticke\n      get :get_ticket, :read \n      # create a field called `most_important_ticket` that uses the `most_important` read action to fetch a single record\n      read_one :most_important_ticket, :most_important \n\n      # create a field called `list_tickets` that uses the `read` read action to fetch a list of tickets\n      list :list_tickets, :read \n    end\n\n    mutations do\n      # Examples\n\n      create :create_ticket, :create\n      update :update_ticket, :update\n      destroy :destroy_ticket, :destroy\n    end\n  end\n\n  ...\nend\n```","ref":"getting-started-with-graphql.html#add-graphql-to-your-resources","title":"Add graphql to your resources - Getting Started With Graphql","type":"extras"},{"doc":"If you don't have an absinthe schema, you can create one just for ash.\n\nDefine a `context/1` function, and call `AshGraphql.add_context/2` with the current context and your apis. Additionally, add the `Absinthe.Middleware.Dataloader` to your plugins, as shown below. If you're starting fresh, just copy the schema below and adjust the module name and api name.\n\n```elixir\ndefmodule Helpdesk.Schema do\n  use Absinthe.Schema\n\n  @apis [Helpdesk.Support]\n\n  use AshGraphql, apis: @apis\n\n  # The query and mutation blocks is where you can add custom absinthe code\n  query do\n  end\n\n  mutation do\n  end\nend\n```","ref":"getting-started-with-graphql.html#add-ashgraphql-to-your-schema","title":"Add AshGraphql to your schema - Getting Started With Graphql","type":"extras"},{"doc":"#","ref":"getting-started-with-graphql.html#connect-your-schema","title":"Connect your schema - Getting Started With Graphql","type":"extras"},{"doc":"If you are unfamiliar with how plug works, this [guide](https://elixirschool.com/en/lessons/specifics/plug/#dependencies) will be helpful for understanding it. It also guides you through\nadding plug to your application.\n\nThen you can use a `Plug.Router` and [forward](https://hexdocs.pm/plug/Plug.Router.html#forward/2) to your plugs similar to how it is done for phoenix:\n\n```elixir\nplug AshGraphql.Plug\n\nforward \"/gql\",\n  to: Absinthe.Plug,\n  init_opts: [schema: Helpdesk.Schema]\n\nforward \"/playground\",\n  to: Absinthe.Plug.GraphiQL,\n  init_opts: [\n    schema: Helpdesk.Schema,\n    interface: :playground\n  ]\n```\n\n#","ref":"getting-started-with-graphql.html#using-plug","title":"Using Plug - Getting Started With Graphql","type":"extras"},{"doc":"You will simply want to add some code to your router, like so.\n\nYou will also likely want to set up the \"playground\" for trying things out.\n\n```elixir\npipeline :graphql do\n  plug AshGraphql.Plug\nend\n\nscope \"/\" do\n  pipe_through [:graphql]\n\n  forward \"/gql\", Absinthe.Plug, schema: Helpdesk.Schema\n\n  forward \"/playground\",\n          Absinthe.Plug.GraphiQL,\n          schema: Helpdesk.Schema,\n          interface: :playground\nend\n```\n\nIf you started with `mix new ...` instead of `mix phx.new ...` and you want to\nstill use phoenix, the fastest path that way is typically to just create a new\nphoenix application and copy your resources/config over.","ref":"getting-started-with-graphql.html#using-phoenix","title":"Using Phoenix - Getting Started With Graphql","type":"extras"},{"doc":"Topics:\n- [GraphQL Generation](/documentation/topics/graphql-generation.md)\n\nHow Tos:\n- [Authorize With GraphQL](/documentation/how_to/authorize-with-graphql.md)\n- [Handle Errors](/documentation/how_to/handle-errors.md)\n- [Use Enums with GraphQL](/documentation/how_to/use-enums-with-graphql.md)\n- [Use JSON with GraphQL](/documentation/how_to/use-json-with-graphql.md)\n\n[Monitoring](/documentation/monitoring.md)","ref":"getting-started-with-graphql.html#what-s-next","title":"What's next? - Getting Started With Graphql","type":"extras"}]}